<?php  namespace Concrete\Package\EzEvent\Block\EzEvent;
use \Concrete\Core\Block\BlockController;
use File;
use Core;
use AssetList;
use \Concrete\Core\Asset\Asset;

class Controller extends BlockController
{
    protected $btTable = 'btEzEvent';
    protected $btInterfaceWidth = "600";
    protected $btWrapperClass = 'ccm-ui';
    protected $btInterfaceHeight = "465";

    public function getBlockTypeDescription() {
        return t("Easily add event info to any page.");
    }

    public function getBlockTypeName() {
        return t("EZ Event");
    }

	public function registerAssets($outputContent = '') { 
        $this->requireAsset('css','font-awesome');   
    }
	public function add() {
        $this->edit();
    }
	public function edit() {
		$this->requireAsset('redactor');
		$this->requireAsset('core/sitemap');
		$this->requireAsset('core/file-manager');
	}

	public function getFileID() {
        return $this->fID;
    }
	public function getFileObject() {
        return File::getByID($this->fID);
    }
	public function validate($args) {
        $e = Core::make("helper/validation/error");       
		if(empty($args['eventtitle'])){
            $e->add(t("Event Title is required."));
        }
		if(strlen($args['eventtitle']) > 255) {
			$e->add(t("Event Title cannot exceed 255 characters."));
		}
		if(strlen($args['host']) > 100) {
			$e->add(t("Host name cannot exceed 100 characters."));
		}
		if(strlen($args['ephone']) > 15) {
			$e->add(t("Phone number cannot exceed 15 characters."));
		}
		if(strlen($args['location1']) > 255) {
			$e->add(t("Location line 1 cannot exceed 255 characters."));
		}
		if(strlen($args['location2']) > 255) {
			$e->add(t("Location line 2 cannot exceed 255 characters."));
		}
		if(strlen($args['fbevent']) > 255) {
			$e->add(t("Facebook Event cannot exceed 255 characters."));
		}
		if(strlen($args['gcal']) > 255) {
			$e->add(t("Google Calendar cannot exceed 255 characters."));
		}
		if(strlen($args['meetup']) > 255) {
			$e->add(t("Meetup cannot exceed 255 characters."));
		}
		if(strlen($args['eventbrite']) > 255) {
			$e->add(t("Eventbrite cannot exceed 255 characters."));
		}
		
		if(empty($args['fID'])){
            $e->add(t("Cover Image is required."));
        } elseif (!empty($args['fID'])) {
			$f = File::getByID($args['fID']); // Get the file	
			$fv = $f->getVersion();  // Get the file version
			$fileType = $fv->getExtension();  // Get the file extension
			$ftypes = array("jpg", "JPG", "jpeg", "png", "PNG"); // Define array of file types.
			if(!in_array($fileType, $ftypes)) {   // If the file extension is NOT in the array, return this error.
				$e->add(t("Invalid background image type. Please select either a PNG or JPG file."));
			}
		}
        return $e;
    }
	
	public function save($args) {
		$args['eventdate'] = Core::make('helper/form/date_time')->translate('eventdate');
		$args['eventdateend'] = Core::make('helper/form/date_time')->translate('eventdateend');
		$args['evHeight'] 	= is_numeric($args['evHeight']) ? intval($args['evHeight']) : '200';
		$args['handicap'] = intval($args['handicap']);
		$args['signing'] = intval($args['signing']);
		$args['closedcap'] = intval($args['closedcap']);
		$args['lodging'] = intval($args['lodging']);
		$args['transport'] = intval($args['transport']);
		$args['maplink'] = intval($args['maplink']);
		parent::save($args);
	}

}
